{$APPTYPE CONSOLE}

uses
  SysUtils, Math;

var
  fo: textfile;
  comp, vert, edges, eConn: integer;
  ans, cans: integer;
  b: array of boolean;
  i, j, idx, ii, jj: integer;
  comps, vcnt: array of integer;
begin
  AssignFile(fo, 'input.txt');
  ReWrite(fo);
  vert := StrToInt(Paramstr(1));
  comp := StrToInt(Paramstr(2));
  edges := StrToInt(Paramstr(3));
  RandSeed := StrToInt(Paramstr(4));
  Random(10);

  SetLength(b, vert + comp - 1);
  FillChar(b[0], Length(b), false);
  for i := 1 to comp - 1 do begin
    repeat
      idx := Random(Length(b));
    until
      (idx <> 0) and (idx <> High(b)) and (not b[idx]) and
      (not b[idx - 1]) and (not b[idx + 1]);
    b[idx] := true;
  end;

  SetLength(comps, comp);
  FillChar(comps[0], SizeOf(integer) * comp, 0);
  idx := 0;
  for i := 0 to High(b) do begin
    if (b[i]) then
      Inc(idx)
    else
      Inc(comps[idx]);
  end;

  for i := 0 to comp - 1 do
    if (comps[i] > 1) then
      Inc(edges, comps[i] - 1);

  WriteLn(fo, vert, ' ', edges);

  SetLength(vcnt, vert);
  FillChar(vcnt[0], SizeOf(integer) * vert, 0);
  idx := 0;
  eConn := 0;
  for i := 0 to comp - 1 do begin
    for j := 1 to comps[i] - 1 do begin
      Write(fo, idx + 1, ' ', j + idx + 1, '  ');
      Inc(vcnt[idx]);
      Inc(vcnt[j + idx]);
      Inc(eConn);
    end;
    WriteLn(fo);
    Inc(idx, comps[i]);
  end;

  for i := eConn + 1 to edges do begin
    repeat
      idx := Random(comp);
    until (comps[idx] > 1);
    repeat
      ii := Random(comps[idx]);
      jj := Random(comps[idx]);
    until (ii <> jj);
    for j := 0 to idx - 1 do begin
      Inc(ii, comps[j]);
      Inc(jj, comps[j]);
    end;
    Inc(vcnt[ii]);
    Inc(vcnt[jj]);
    Write(fo, ii + 1, ' ', jj + 1, '  ');
  end;

  ans := 0;
  idx := 0;
  for i := 0 to comp - 1 do begin
    cans := 0;
    for j := 0 to comps[i] - 1 do
      if (vcnt[idx + j] mod 2 = 1) then
        Inc(cans);
    cans := cans div 2;
    cans := Max(cans, 1);
    Inc(ans, cans);
    Inc(idx, comps[i]);
  end;
  WriteLn('Generator: expected ', ans);
  
  CloseFile(fo);
end.
